summaryrefslogtreecommitdiffstats
path: root/scripts/setlocalversion
diff options
context:
space:
mode:
authorMarc Kleine-Budde <mkl@pengutronix.de>2011-03-20 22:44:35 +0100
committerMarc Kleine-Budde <mkl@pengutronix.de>2011-03-22 11:02:49 +0100
commit05b2f6b5d141dc888f753fd531cf6bbf4889f3a0 (patch)
treec02dc6311414fad3a8aa6a12f02ba957d54b9962 /scripts/setlocalversion
parentae8c6f417e9f5259ecc4ddd6dfa09f309db97c61 (diff)
downloadOSELAS.Toolchain-05b2f6b5d141dc888f753fd531cf6bbf4889f3a0.tar.gz
OSELAS.Toolchain-05b2f6b5d141dc888f753fd531cf6bbf4889f3a0.tar.xz
makefile: add make {dist,release} target
Signed-off-by: Marc Kleine-Budde <mkl@pengutronix.de>
Diffstat (limited to 'scripts/setlocalversion')
-rwxr-xr-xscripts/setlocalversion111
1 files changed, 111 insertions, 0 deletions
diff --git a/scripts/setlocalversion b/scripts/setlocalversion
new file mode 100755
index 0000000..63928cd
--- /dev/null
+++ b/scripts/setlocalversion
@@ -0,0 +1,111 @@
+#!/bin/sh
+#
+# This scripts adds local version information from the version
+# control systems git, mercurial (hg) and subversion (svn).
+#
+# If something goes wrong, send a mail the kernel build mailinglist
+# (see MAINTAINERS) and CC Nico Schottelius
+# <nico-linuxsetlocalversion -at- schottelius.org>.
+#
+#
+
+#
+# Use the following line in your configure.ac, so that $(VERSION) will
+# automatically be up-to-date each time configure is run (and note that
+# since configure.ac no longer includes a version string, Makefile rules
+# should not depend on configure.ac for version updates).
+#
+# AC_INIT([GNU project],
+# m4_esyscmd([build-aux/git-version-gen .tarball-version]),
+# [bug-project@example])
+#
+
+case $# in
+ 1) ;;
+ *) echo 1>&2 "Usage: $0 \$srcdir/.tarball-version"; exit 1;;
+esac
+
+tarball_version_file="$1"
+nl='
+'
+
+# First see if there is a tarball-only version file.
+if test -f $tarball_version_file
+then
+ v=`cat $tarball_version_file` || exit 1
+ case $v in
+ *$nl*) v= ;; # reject multi-line output
+ esac
+ test -z "$v" \
+ && echo "$0: WARNING: $tarball_version_file seems to be damaged" 1>&2
+
+ echo -n "$v"
+ exit
+fi
+
+cd "$(dirname "${tarball_version_file}")"
+
+# Check for git and a git repo.
+if head=`git rev-parse --verify --short HEAD 2>/dev/null`; then
+
+ # If we are at a tagged commit (like "ptxdist-2010.05.0"), we
+ # print it here
+ if atag="`git describe --exact-match 2>/dev/null`"; then
+ echo "$atag" | awk -F'[v-]' '{printf("%s", $(NF))}'
+
+ # If we are past a tagged commit (like "ptxdist-2010.03.0-130-g3c60777"),
+ # we pretty print it.
+ elif atag="`git describe 2>/dev/null`"; then
+ echo "$atag" | awk -F'[v-]' '{printf("%s-%05d-%s", $(NF-2),$(NF-1),$(NF))}'
+
+ # If we don't have a tag at all we print ????.??.?-?-g{commitish}.
+ else
+ printf '%s%s' '????.??.?-?-g' $head
+ fi
+
+ # Is this git on svn?
+ if git config --get svn-remote.svn.url >/dev/null; then
+ printf -- '-svn%s' "`git svn find-rev $head`"
+ fi
+
+ # Update index only on r/w media
+ [ -w . ] && git update-index --refresh --unmerged > /dev/null
+
+ # Check for uncommitted changes
+ if git diff-index --name-only HEAD \
+ | read dummy; then
+ printf '%s' -dirty
+ fi
+
+ # All done with git
+ exit
+fi
+
+# Check for mercurial and a mercurial repo.
+if hgid=`hg id 2>/dev/null`; then
+ tag=`printf '%s' "$hgid" | cut -d' ' -f2`
+
+ # Do we have an untagged version?
+ if [ -z "$tag" -o "$tag" = tip ]; then
+ id=`printf '%s' "$hgid" | sed 's/[+ ].*//'`
+ printf '%s%s' hg "$id"
+ fi
+
+ # Are there uncommitted changes?
+ # These are represented by + after the changeset id.
+ case "$hgid" in
+ *+|*+\ *) printf '%s' -dirty ;;
+ esac
+
+ # All done with mercurial
+ exit
+fi
+
+# Check for svn and a svn repo.
+if rev=`svn info 2>/dev/null | grep '^Last Changed Rev'`; then
+ rev=`echo $rev | awk '{print $NF}'`
+ printf -- 'svn%s' "$rev"
+
+ # All done with svn
+ exit
+fi